// Copyright 2017 by Yun Xiang, Tam Chantem, and Robert Dick.
// All rights reserved.

/*Copyright 2010, Robert Dick<dickrp@eecs.umich.edu>.*/
#include "SString.h"

#include <algorithm>
#include <functional>
#include <string>
#include <cstring>
#include <iostream>

using namespace std;

/*###########################################################################*/
namespace {
    template <typename T>
    T convert(const string & s) {
        istringstream iss(s.c_str());
        //double dbl;
        T dbl;
        iss >> dbl;
//        Sassert(! iss.bad());
        return static_cast<T>(dbl);
    }
}

Conv::Conv(const string & str) :
	str_(str)
{}

/*===========================================================================*/
Conv::operator bool()
	{ return convert<bool>(str_); }

Conv::operator char()
	{ return convert<char>(str_); }

Conv::operator signed char()
	{ return convert<char>(str_); }

Conv::operator unsigned char()
	{ return convert<unsigned char>(str_); }

Conv::operator short()
	{ return convert<short>(str_); }

Conv::operator unsigned short()
	{ return convert<unsigned short>(str_); }

Conv::operator int()
	{ return convert<int>(str_); }

Conv::operator unsigned()
	{ return convert<unsigned>(str_); }

Conv::operator long()
	{ return convert<long>(str_); }

Conv::operator unsigned long()
	{ return convert<unsigned long>(str_); }

Conv::operator float()
	{ return convert<float>(str_); }

Conv::operator double()
	{ return convert<double>(str_); }

/*===========================================================================*/
