// Copyright 2017 by Yun Xiang, Tam Chantem, and Robert Dick.
// All rights reserved.

/*Copyright 2010, Yun Xiang<xiangyun@umich.edu>.*/
#ifndef STATS_H_
#define STATS_H_

#include "RVector.h"

/*##########################################################################*/
            
namespace rstd{

/*==========================================================================*/	
// Support routine for lognormal distribution


/*==========================================================================*/	
double gamma_(double x);

double erfcore(double x, int jint);

double erfcinv(double t);

double erfc(double x);

double erf(double x);
/*==========================================================================*/
 double unirnd();
 double wblrnd(double eta, double beta);
 double normrnd(double mu, double sigma);
 double wblinv_PV(double p,double eta, double mu, double sigma, int n);
 long double wblcdf_PV(double x,double eta, double mu, double sigma, int n);
/*==========================================================================*/	
double normcdf(double x,double mu,double sigma);

 double norminv( double p, double mu, double sigma);

double logncdf(double x, double mu, double sigma);

double wblcdf(double x, double mu, double sigma);

double wblpdf (double x, double mu, double sigma);

double logninv(double p,double mu,double sigma);

double lognpdf(double x,double mu,double sigma);

double lognmean(double mu, double sigma);

double wblintegral(double mu, double sigma, double start, double end);

 double wblinv(double p, double mu, double sigma);
/*==========================================================================*/	
void normfit(const RVector<double>& x, double& mu, double& sigma);

void lognfit(const RVector<double>& data, double& mu, double& sigma);

void lognfit(const RVector<double>& Ft, const RVector<double>& t, 
			double& mu, double& sigma);
void lognfit(const RVector<double>& mu_vec, const RVector<double>& sigma_vec,
			const double& threshold, double& mu, double& sigma);
void wblfit(const RVector<double>& Ft, const RVector<double>& t, 
			double& mu, double& sigma);
void wblfit(const RVector<double>& mu_vec, const RVector<double>& sigma_vec,
			const double& threshold, double& mu, double& sigma);

//it is added for debugging
//void lognfit(RVector<double>& mu_vec, RVector<double>& sigma_vec,
//			double threshold, const double& mu,const double& sigma);

/*==========================================================================*/	
void lognfit2_test();

}


#endif
